diff --git a/python/mozbuild/mozbuild/compilation/util.py b/python/mozbuild/mozbuild/compilation/util.py
index 32ff2f8767..0f980e9a58 100644
--- a/python/mozbuild/mozbuild/compilation/util.py
+++ b/python/mozbuild/mozbuild/compilation/util.py
@@ -2,6 +2,7 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this file,
 # You can obtain one at http://mozilla.org/MPL/2.0/.
 
+from __future__ import print_function
 import os
 from mozbuild import shellutil
 
diff --git a/python/mozbuild/mozbuild/compilation/warnings.py b/python/mozbuild/mozbuild/compilation/warnings.py
index 8fb20ccbff..8fd16fb4c7 100644
--- a/python/mozbuild/mozbuild/compilation/warnings.py
+++ b/python/mozbuild/mozbuild/compilation/warnings.py
@@ -4,7 +4,6 @@
 
 # This modules provides functionality for dealing with compiler warnings.
 
-from __future__ import absolute_import, unicode_literals
 
 import errno
 import json
@@ -94,7 +93,7 @@ class CompilerWarning(dict):
         return hash(tuple(sorted(self.items())))
 
 
-class WarningsDatabase(object):
+class WarningsDatabase:
     """Holds a collection of warnings.
 
     The warnings database is a semi-intelligent container that holds warnings
@@ -130,8 +129,7 @@ class WarningsDatabase(object):
 
     def __iter__(self):
         for value in self._files.values():
-            for warning in value['warnings']:
-                yield warning
+            yield from value['warnings']
 
     def __contains__(self, item):
         for value in self._files.values():
@@ -145,8 +143,7 @@ class WarningsDatabase(object):
     def warnings(self):
         """All the CompilerWarning instances in this database."""
         for value in self._files.values():
-            for w in value['warnings']:
-                yield w
+            yield from value['warnings']
 
     def type_counts(self, dirpath=None):
         """Returns a mapping of warning types to their counts."""
@@ -172,8 +169,7 @@ class WarningsDatabase(object):
         """Obtain the warnings for the specified file."""
         f = self._files.get(filename, {'warnings': []})
 
-        for warning in f['warnings']:
-            yield warning
+        yield from f['warnings']
 
     def insert(self, warning, compute_hash=True):
         assert isinstance(warning, CompilerWarning)
@@ -210,7 +206,7 @@ class WarningsDatabase(object):
         """
 
         # Need to calculate up front since we are mutating original object.
-        filenames = self._files.keys()
+        filenames = list(self._files.keys())
         for filename in filenames:
             if not os.path.exists(filename):
                 del self._files[filename]
@@ -229,10 +225,10 @@ class WarningsDatabase(object):
         obj = {'files': {}}
 
         # All this hackery because JSON can't handle sets.
-        for k, v in self._files.iteritems():
+        for k, v in self._files.items():
             obj['files'][k] = {}
 
-            for k2, v2 in v.iteritems():
+            for k2, v2 in v.items():
                 normalized = v2
 
                 if k2 == 'warnings':
@@ -249,8 +245,8 @@ class WarningsDatabase(object):
         self._files = obj['files']
 
         # Normalize data types.
-        for filename, value in self._files.iteritems():
-            for k, v in value.iteritems():
+        for filename, value in self._files.items():
+            for k, v in value.items():
                 if k != 'warnings':
                     continue
 
@@ -275,11 +271,11 @@ class WarningsDatabase(object):
         except OSError as e:
             if e.errno != errno.EEXIST:
                 raise
-        with open(filename, 'wb') as fh:
+        with open(filename, 'w') as fh:
             self.serialize(fh)
 
 
-class WarningsCollector(object):
+class WarningsCollector:
     """Collects warnings from text data.
 
     Instances of this class receive data (usually the output of compiler
diff --git a/python/mozbuild/mozbuild/config_status.py b/python/mozbuild/mozbuild/config_status.py
index 80725fcc56..584e643e1d 100644
--- a/python/mozbuild/mozbuild/config_status.py
+++ b/python/mozbuild/mozbuild/config_status.py
@@ -6,7 +6,6 @@
 # drop-in replacement for autoconf 2.13's config.status, with features
 # borrowed from autoconf > 2.5, and additional features.
 
-from __future__ import absolute_import, print_function
 
 import logging
 import os
@@ -63,7 +62,11 @@ def config_status(topobjdir='.', topsrcdir='.', defines=None,
             '%s' % topsrcdir)
 
     default_backends = ['RecursiveMake']
-    default_backends = (substs or {}).get('BUILD_BACKENDS', ['RecursiveMake'])
+    _raw_backends = (substs or {}).get('BUILD_BACKENDS') or \
+                    (substs or {}).get(b'BUILD_BACKENDS')
+    if _raw_backends is not None:
+        default_backends = [v.decode() if isinstance(v, bytes) else v
+                            for v in _raw_backends]
 
     parser = ArgumentParser()
     parser.add_argument('-v', '--verbose', dest='verbose', action='store_true',
@@ -93,7 +96,7 @@ def config_status(topobjdir='.', topsrcdir='.', defines=None,
     if 'WRITE_MOZINFO' in os.environ:
         write_mozinfo(os.path.join(topobjdir, 'mozinfo.json'), env, os.environ)
 
-    cpu_start = time.clock()
+    cpu_start = time.perf_counter()
     time_start = time.time()
 
     # Make appropriate backend instances, defaulting to RecursiveMakeBackend,
@@ -142,7 +145,7 @@ def config_status(topobjdir='.', topsrcdir='.', defines=None,
         'Whistling in the dark',
     ]
 
-    print('{0}...'.format(random.choice(STATUS_MESSAGES)), file=sys.stderr)
+    print('{}...'.format(random.choice(STATUS_MESSAGES)), file=sys.stderr)
     sys.stderr.flush()
 
     if len(selected_backends) > 1:
@@ -157,7 +160,7 @@ def config_status(topobjdir='.', topsrcdir='.', defines=None,
         print(summary, file=sys.stderr)
         execution_time += summary.execution_time
 
-    cpu_time = time.clock() - cpu_start
+    cpu_time = time.perf_counter() - cpu_start
     wall_time = time.time() - time_start
     efficiency = cpu_time / wall_time if wall_time else 100
     untracked = wall_time - execution_time
diff --git a/python/mozbuild/mozbuild/configure/__init__.py b/python/mozbuild/mozbuild/configure/__init__.py
index a59876fcae..d7260cf52c 100644
--- a/python/mozbuild/mozbuild/configure/__init__.py
+++ b/python/mozbuild/mozbuild/configure/__init__.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, print_function, unicode_literals
 
 import inspect
 import logging
@@ -43,14 +42,14 @@ class ConfigureError(Exception):
     pass
 
 
-class SandboxDependsFunction(object):
+class SandboxDependsFunction:
     '''Sandbox-visible representation of @depends functions.'''
     def __call__(self, *arg, **kwargs):
         raise ConfigureError('The `%s` function may not be called'
                              % self.__name__)
 
 
-class DependsFunction(object):
+class DependsFunction:
     __slots__ = (
         'func', 'dependencies', 'when', 'sandboxed', 'sandbox', '_result')
 
@@ -90,7 +89,7 @@ class DependsFunction(object):
         return self.func(*resolved_args)
 
     def __repr__(self):
-        return '<%s.%s %s(%s)>' % (
+        return '<{}.{} {}({})>'.format(
             self.__class__.__module__,
             self.__class__.__name__,
             self.name,
@@ -122,7 +121,7 @@ class CombinedDependsFunction(DependsFunction):
                 flatten_deps.insert(0, sandbox._help_option)
                 break
 
-        super(CombinedDependsFunction, self).__init__(
+        super().__init__(
             sandbox, wrapper, flatten_deps)
 
     @memoized_property
@@ -142,6 +141,9 @@ class CombinedDependsFunction(DependsFunction):
     def __ne__(self, other):
         return not self == other
 
+    def __hash__(self):
+        return id(self)
+
 class SandboxedGlobal(dict):
     '''Identifiable dict type for use as function global'''
 
@@ -192,9 +194,10 @@ class ConfigureSandbox(dict):
         b: __builtins__[b]
         for b in ('None', 'False', 'True', 'int', 'bool', 'any', 'all', 'len',
                   'list', 'tuple', 'set', 'dict', 'isinstance', 'getattr',
-                  'hasattr', 'enumerate', 'range', 'zip', '__build_class__')
+                  'hasattr', 'enumerate', 'range', 'zip', '__build_class__',
+                  'exec')
         if b in __builtins__},
-    __import__=forbidden_import, str=unicode)
+    __import__=forbidden_import, str=str)
 
     # Expose a limited set of functions from os.path
     OS = ReadOnlyNamespace(path=ReadOnlyNamespace(**{
@@ -268,7 +271,7 @@ class ConfigureSandbox(dict):
                 return method
             def wrapped(*args, **kwargs):
                 out_args = [
-                    arg.decode(encoding) if isinstance(arg, str) else arg
+                    arg.decode(encoding) if isinstance(arg, bytes) else arg
                     for arg in args
                 ]
                 return method(*out_args, **kwargs)
@@ -334,7 +337,7 @@ class ConfigureSandbox(dict):
         if path:
             self.include_file(path)
 
-        for option in self._options.itervalues():
+        for option in self._options.values():
             # All options must be referenced by some @depends function
             if option not in self._seen:
                 raise ConfigureError(
@@ -373,7 +376,7 @@ class ConfigureSandbox(dict):
         if func:
             return func
 
-        return super(ConfigureSandbox, self).__getitem__(key)
+        return super().__getitem__(key)
 
     def __setitem__(self, key, value):
         if (key in self.BUILTINS or key == '__builtins__' or
@@ -389,7 +392,7 @@ class ConfigureSandbox(dict):
             raise KeyError('Cannot assign `%s` because it is neither a '
                            '@depends nor a @template' % key)
 
-        return super(ConfigureSandbox, self).__setitem__(key, value)
+        return super().__setitem__(key, value)
 
     def _resolve(self, arg, need_help_dependency=True):
         if isinstance(arg, SandboxDependsFunction):
@@ -438,7 +441,7 @@ class ConfigureSandbox(dict):
                     value = PositiveOptionValue()
                 elif value is False or value == ():
                     value = NegativeOptionValue()
-                elif isinstance(value, types.StringTypes):
+                elif isinstance(value, (str,)):
                     value = PositiveOptionValue((value,))
                 elif isinstance(value, tuple):
                     value = PositiveOptionValue(value)
@@ -478,7 +481,7 @@ class ConfigureSandbox(dict):
         return value
 
     def _dependency(self, arg, callee_name, arg_name=None):
-        if isinstance(arg, types.StringTypes):
+        if isinstance(arg, (str,)):
             prefix, name, values = Option.split_option(arg)
             if values != ():
                 raise ConfigureError("Option must not contain an '='")
@@ -542,7 +545,7 @@ class ConfigureSandbox(dict):
         '''
         when = self._normalize_when(kwargs.get('when'), 'option')
         args = [self._resolve(arg) for arg in args]
-        kwargs = {k: self._resolve(v) for k, v in kwargs.iteritems()
+        kwargs = {k: self._resolve(v) for k, v in kwargs.items()
                                       if k != 'when'}
         option = Option(*args, **kwargs)
         if when:
@@ -623,7 +626,7 @@ class ConfigureSandbox(dict):
         with self.only_when_impl(when):
             what = self._resolve(what)
             if what:
-                if not isinstance(what, types.StringTypes):
+                if not isinstance(what, (str,)):
                     raise TypeError("Unexpected type: '%s'" % type(what).__name__)
                 self.include_file(what)
 
@@ -641,7 +644,7 @@ class ConfigureSandbox(dict):
             (k[:-len('_impl')], getattr(self, k))
             for k in dir(self) if k.endswith('_impl') and k != 'template_impl'
         )
-        glob.update((k, v) for k, v in self.iteritems() if k not in glob)
+        glob.update((k, v) for k, v in self.items() if k not in glob)
 
         # Any function argument to the template must be prepared to be sandboxed.
         # If the template itself returns a function (in which case, it's very
@@ -665,7 +668,7 @@ class ConfigureSandbox(dict):
             def wrapper(*args, **kwargs):
                 args = [maybe_prepare_function(arg) for arg in args]
                 kwargs = {k: maybe_prepare_function(v)
-                          for k, v in kwargs.iteritems()}
+                          for k, v in kwargs.items()}
                 ret = template(*args, **kwargs)
                 if isfunction(ret):
                     # We can't expect the sandboxed code to think about all the
@@ -684,7 +687,7 @@ class ConfigureSandbox(dict):
         self._templates.add(wrapper)
         return wrapper
 
-    RE_MODULE = re.compile('^[a-zA-Z0-9_\.]+$')
+    RE_MODULE = re.compile(r'^[a-zA-Z0-9_\.]+$')
 
     def imports_impl(self, _import, _from=None, _as=None):
         '''Implementation of @imports.
@@ -697,7 +700,7 @@ class ConfigureSandbox(dict):
         for value, required in (
                 (_import, True), (_from, False), (_as, False)):
 
-            if not isinstance(value, types.StringTypes) and (
+            if not isinstance(value, (str,)) and (
                     required or value is not None):
                 raise TypeError("Unexpected type: '%s'" % type(value).__name__)
             if value is not None and not self.RE_MODULE.match(value):
@@ -725,10 +728,10 @@ class ConfigureSandbox(dict):
         for _from, _import, _as in self._imports.get(func, ()):
             _from = '%s.' % _from if _from else ''
             if _as:
-                glob[_as] = self._get_one_import('%s%s' % (_from, _import))
+                glob[_as] = self._get_one_import('{}{}'.format(_from, _import))
             else:
                 what = _import.split('.')[0]
-                glob[what] = self._get_one_import('%s%s' % (_from, what))
+                glob[what] = self._get_one_import('{}{}'.format(_from, what))
 
     def _get_one_import(self, what):
         # The special `__sandbox__` module gives access to the sandbox
@@ -738,8 +741,12 @@ class ConfigureSandbox(dict):
         # Special case for the open() builtin, because otherwise, using it
         # fails with "IOError: file() constructor not accessible in
         # restricted mode"
-        if what == '__builtin__.open':
+        if what in ('__builtin__.open', 'builtins.open'):
             return lambda *args, **kwargs: open(*args, **kwargs)
+        # Python 3: __builtin__ was renamed to builtins
+        what = what.replace('__builtin__.', 'builtins.')
+        if what == '__builtin__':
+            what = 'builtins'
         # Until this proves to be a performance problem, just construct an
         # import statement and execute it.
         import_line = ''
@@ -760,7 +767,7 @@ class ConfigureSandbox(dict):
         name = self._resolve(name, need_help_dependency=False)
         if name is None:
             return
-        if not isinstance(name, types.StringTypes):
+        if not isinstance(name, (str,)):
             raise TypeError("Unexpected type: '%s'" % type(name).__name__)
         if name in data:
             raise ConfigureError(
@@ -850,11 +857,11 @@ class ConfigureSandbox(dict):
                 if isinstance(possible_reasons[0], Option):
                     reason = possible_reasons[0]
         if not reason and (isinstance(value, (bool, tuple)) or
-                           isinstance(value, types.StringTypes)):
+                           isinstance(value, (str,))):
             # A reason can be provided automatically when imply_option
             # is called with an immediate value.
             _, filename, line, _, _, _ = inspect.stack()[1]
-            reason = "imply_option at %s:%s" % (filename, line)
+            reason = "imply_option at {}:{}".format(filename, line)
 
         if not reason:
             raise ConfigureError(
@@ -885,10 +892,10 @@ class ConfigureSandbox(dict):
         if not inspect.isfunction(func):
             raise TypeError("Unexpected type: '%s'" % type(func).__name__)
         if func in self._prepared_functions:
-            return func, func.func_globals
+            return func, func.__globals__
 
         glob = SandboxedGlobal(
-            (k, v) for k, v in func.func_globals.iteritems()
+            (k, v) for k, v in func.__globals__.items()
             if (inspect.isfunction(v) and v not in self._templates) or (
                 inspect.isclass(v) and issubclass(v, Exception))
         )
@@ -909,20 +916,20 @@ class ConfigureSandbox(dict):
         # Note this is not entirely bullet proof (if the value is e.g. a list,
         # the list contents could have changed), but covers the bases.
         closure = None
-        if func.func_closure:
+        if func.__closure__:
             def makecell(content):
                 def f():
                     content
-                return f.func_closure[0]
+                return f.__closure__[0]
 
             closure = tuple(makecell(cell.cell_contents)
-                            for cell in func.func_closure)
+                            for cell in func.__closure__)
 
         new_func = wraps(func)(types.FunctionType(
-            func.func_code,
+            func.__code__,
             glob,
             func.__name__,
-            func.func_defaults,
+            func.__defaults__,
             closure
         ))
         @wraps(new_func)
diff --git a/python/mozbuild/mozbuild/configure/check_debug_ranges.py b/python/mozbuild/mozbuild/configure/check_debug_ranges.py
index ca312dff47..5c6e1e9841 100644
--- a/python/mozbuild/mozbuild/configure/check_debug_ranges.py
+++ b/python/mozbuild/mozbuild/configure/check_debug_ranges.py
@@ -6,8 +6,8 @@
 # to a given compilation unit. This is used as a helper to find a bug in some
 # versions of GNU ld.
 
-from __future__ import absolute_import
 
+from __future__ import print_function
 import subprocess
 import sys
 import re
@@ -37,7 +37,7 @@ def get_range_length(range, debug_ranges):
        given offset.'''
     length = 0
     for line in debug_ranges.splitlines():
-        m = re.match('\s*([0-9a-fA-F]+)\s+([0-9a-fA-F]+)\s+([0-9a-fA-F]+)', line)
+        m = re.match(r'\s*([0-9a-fA-F]+)\s+([0-9a-fA-F]+)\s+([0-9a-fA-F]+)', line)
         if m and int(m.group(1), 16) == range:
             length += 1
     return length
@@ -59,4 +59,4 @@ def main(bin, compilation_unit):
 
 
 if __name__ == '__main__':
-    print main(*sys.argv[1:])
+    print((main(*sys.argv[1:])))
diff --git a/python/mozbuild/mozbuild/configure/constants.py b/python/mozbuild/mozbuild/configure/constants.py
index 9e30dd8418..fe41c80d26 100644
--- a/python/mozbuild/mozbuild/configure/constants.py
+++ b/python/mozbuild/mozbuild/configure/constants.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, print_function, unicode_literals
 
 from mozbuild.util import EnumString
 from collections import OrderedDict
@@ -58,7 +57,7 @@ CPU_bitness = {
     'x86_64': 64,
 }
 
-CPU = EnumString.subclass(*CPU_bitness.keys())
+CPU = EnumString.subclass(*list(CPU_bitness.keys()))
 
 Endianness = EnumString.subclass(
     'big',
diff --git a/python/mozbuild/mozbuild/configure/help.py b/python/mozbuild/mozbuild/configure/help.py
index cd7876fbd1..afa0f69c31 100644
--- a/python/mozbuild/mozbuild/configure/help.py
+++ b/python/mozbuild/mozbuild/configure/help.py
@@ -2,13 +2,12 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, print_function, unicode_literals
 
 import os
 from mozbuild.configure.options import Option
 
 
-class HelpFormatter(object):
+class HelpFormatter:
     def __init__(self, argv0):
         self.intro = ['Usage: %s [options]' % os.path.basename(argv0)]
         self.options = ['Options: [defaults in brackets after descriptions]']
@@ -35,7 +34,7 @@ class HelpFormatter(object):
         if len(opt) > 24 or not help:
             target.append('  %s' % opt)
             if help:
-                target.append('%s%s' % (' ' * 28, help))
+                target.append('{}{}'.format(' ' * 28, help))
         else:
             target.append('  %-24s  %s' % (opt, help))
 
diff --git a/python/mozbuild/mozbuild/configure/lint.py b/python/mozbuild/mozbuild/configure/lint.py
index e0a5c8328d..91150c7765 100644
--- a/python/mozbuild/mozbuild/configure/lint.py
+++ b/python/mozbuild/mozbuild/configure/lint.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, print_function, unicode_literals
 
 from StringIO import StringIO
 from . import (
@@ -23,7 +22,7 @@ class LintSandbox(ConfigureSandbox):
         environ = environ or {}
         argv = argv or []
         self._wrapped = {}
-        super(LintSandbox, self).__init__({}, environ=environ, argv=argv,
+        super().__init__({}, environ=environ, argv=argv,
                                           stdout=stdout, stderr=stderr)
 
     def run(self, path=None):
@@ -42,7 +41,7 @@ class LintSandbox(ConfigureSandbox):
             # - don't use @imports
             # - don't have a closure
             # - don't use global variables
-            if func in self._imports or func.func_closure:
+            if func in self._imports or func.__closure__:
                 return True
             for op, arg in disassemble_as_iter(func):
                 if op in ('LOAD_GLOBAL', 'STORE_GLOBAL'):
@@ -68,11 +67,11 @@ class LintSandbox(ConfigureSandbox):
               self._missing_help_dependency(obj)):
             raise ConfigureError("Missing @depends for `%s`: '--help'" %
                                  obj.name)
-        return super(LintSandbox, self)._value_for_depends(
+        return super()._value_for_depends(
             obj, need_help_dependency)
 
     def _prepare_function(self, func):
-        wrapped, glob = super(LintSandbox, self)._prepare_function(func)
+        wrapped, glob = super()._prepare_function(func)
         if wrapped not in self._wrapped:
             self._wrapped[wrapped] = func, glob
         return wrapped, glob
diff --git a/python/mozbuild/mozbuild/configure/lint_util.py b/python/mozbuild/mozbuild/configure/lint_util.py
index f1c2f8731b..dbb6da86ad 100644
--- a/python/mozbuild/mozbuild/configure/lint_util.py
+++ b/python/mozbuild/mozbuild/configure/lint_util.py
@@ -12,9 +12,9 @@ import inspect
 # returns an iterator.
 def disassemble_as_iter(co):
     if inspect.ismethod(co):
-        co = co.im_func
+        co = co.__func__
     if inspect.isfunction(co):
-        co = co.func_code
+        co = co.__code__
     code = co.co_code
     n = len(code)
     i = 0
@@ -30,7 +30,7 @@ def disassemble_as_iter(co):
             extended_arg = 0
             i += 2
             if op == dis.EXTENDED_ARG:
-                extended_arg = arg * 65536L
+                extended_arg = arg * 65536
                 continue
             if op in dis.hasconst:
                 yield opname, co.co_consts[arg]
diff --git a/python/mozbuild/mozbuild/configure/options.py b/python/mozbuild/mozbuild/configure/options.py
index 4310c8627b..902ce81f40 100644
--- a/python/mozbuild/mozbuild/configure/options.py
+++ b/python/mozbuild/mozbuild/configure/options.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, print_function, unicode_literals
 
 import os
 import sys
@@ -12,7 +11,7 @@ from collections import OrderedDict
 
 def istupleofstrings(obj):
     return isinstance(obj, tuple) and len(obj) and all(
-        isinstance(o, types.StringTypes) for o in obj)
+        isinstance(o, (str,)) for o in obj)
 
 
 class OptionValue(tuple):
@@ -24,7 +23,7 @@ class OptionValue(tuple):
     command line, or default)
     '''
     def __new__(cls, values=(), origin='unknown'):
-        return super(OptionValue, cls).__new__(cls, values)
+        return super().__new__(cls, values)
 
     def __init__(self, values=(), origin='unknown'):
         self.origin = origin
@@ -41,29 +40,32 @@ class OptionValue(tuple):
                     prefix = prefix_set[int(bool(self))]
                     break
             if prefix:
-                option = '--%s-%s' % (prefix, name)
+                option = '--{}-{}'.format(prefix, name)
             elif self:
                 option = '--%s' % name
             else:
                 return ''
             if len(self):
-                return '%s=%s' % (option, ','.join(self))
+                return '{}={}'.format(option, ','.join(self))
             return option
         elif self and not len(self):
             return '%s=1' % option
-        return '%s=%s' % (option, ','.join(self))
+        return '{}={}'.format(option, ','.join(self))
 
     def __eq__(self, other):
         if type(other) != type(self):
             return False
-        return super(OptionValue, self).__eq__(other)
+        return super().__eq__(other)
 
     def __ne__(self, other):
         return not self.__eq__(other)
 
+    # Restore tuple's hash since we define __eq__
+    __hash__ = tuple.__hash__
+
     def __repr__(self):
-        return '%s%s' % (self.__class__.__name__,
-                         super(OptionValue, self).__repr__())
+        return '{}{}'.format(self.__class__.__name__,
+                         super().__repr__())
 
 
 class PositiveOptionValue(OptionValue):
@@ -71,9 +73,11 @@ class PositiveOptionValue(OptionValue):
     in the form of a tuple for when values are given to the option (in the form
     --option=value[,value2...].
     '''
-    def __nonzero__(self):
+    def __bool__(self):
         return True
 
+    __nonzero__ = __bool__
+
 
 class NegativeOptionValue(OptionValue):
     '''Represents the value for a negative option (--disable/--without)
@@ -81,10 +85,10 @@ class NegativeOptionValue(OptionValue):
     This is effectively an empty tuple with a `origin` attribute.
     '''
     def __new__(cls, origin='unknown'):
-        return super(NegativeOptionValue, cls).__new__(cls, origin=origin)
+        return super().__new__(cls, origin=origin)
 
     def __init__(self, origin='unknown'):
-        return super(NegativeOptionValue, self).__init__(origin=origin)
+        return super().__init__(origin=origin)
 
 
 class InvalidOptionError(Exception):
@@ -95,12 +99,12 @@ class ConflictingOptionError(InvalidOptionError):
     def __init__(self, message, **format_data):
         if format_data:
             message = message.format(**format_data)
-        super(ConflictingOptionError, self).__init__(message)
-        for k, v in format_data.iteritems():
+        super().__init__(message)
+        for k, v in format_data.items():
             setattr(self, k, v)
 
 
-class Option(object):
+class Option:
     '''Represents a configure option
 
     A configure option can be a command line flag or an environment variable
@@ -132,7 +136,7 @@ class Option(object):
                 'At least an option name or an environment variable name must '
                 'be given')
         if name:
-            if not isinstance(name, types.StringTypes):
+            if not isinstance(name, (str,)):
                 raise InvalidOptionError('Option must be a string')
             if not name.startswith('--'):
                 raise InvalidOptionError('Option must start with `--`')
@@ -141,7 +145,7 @@ class Option(object):
             if not name.islower():
                 raise InvalidOptionError('Option must be all lowercase')
         if env:
-            if not isinstance(env, types.StringTypes):
+            if not isinstance(env, (str,)):
                 raise InvalidOptionError(
                     'Environment variable name must be a string')
             if not env.isupper():
@@ -151,8 +155,8 @@ class Option(object):
                 isinstance(nargs, int) and nargs >= 0):
             raise InvalidOptionError(
                 "nargs must be a positive integer, '?', '*' or '+'")
-        if (not isinstance(default, types.StringTypes) and
-                not isinstance(default, (bool, types.NoneType)) and
+        if (not isinstance(default, (str,)) and
+                not isinstance(default, (bool, type(None))) and
                 not istupleofstrings(default)):
             raise InvalidOptionError(
                 'default must be a bool, a string or a tuple of strings')
@@ -224,7 +228,7 @@ class Option(object):
                     ', '.join("'%s'" % c for c in choices))
         elif has_choices:
             maxargs = self.maxargs
-            if len(choices) < maxargs and maxargs != sys.maxint:
+            if len(choices) < maxargs and maxargs != sys.maxsize:
                 raise InvalidOptionError('Not enough `choices` for `nargs`')
         self.choices = choices
         self.help = help
@@ -238,7 +242,7 @@ class Option(object):
         where prefix is one of 'with', 'without', 'enable' or 'disable'.
         The '=values' part is optional. Values are separated with commas.
         '''
-        if not isinstance(option, types.StringTypes):
+        if not isinstance(option, (str,)):
             raise InvalidOptionError('Option must be a string')
 
         elements = option.split('=', 1)
@@ -271,7 +275,7 @@ class Option(object):
             assert not prefix
             return name
         elif prefix:
-            return '--%s-%s' % (prefix, name)
+            return '--{}-{}'.format(prefix, name)
         return '--%s' % name
 
     @property
@@ -291,7 +295,7 @@ class Option(object):
     def maxargs(self):
         if isinstance(self.nargs, int):
             return self.nargs
-        return 1 if self.nargs == '?' else sys.maxint
+        return 1 if self.nargs == '?' else sys.maxsize
 
     def _validate_nargs(self, num):
         minargs, maxargs = self.minargs, self.maxargs
@@ -331,7 +335,7 @@ class Option(object):
         values = PositiveOptionValue(values, origin=origin)
 
         if not self._validate_nargs(len(values)):
-            raise InvalidOptionError('%s takes %s value%s' % (
+            raise InvalidOptionError('{} takes {} value{}'.format(
                 option,
                 {
                     '?': '0 or 1',
@@ -371,11 +375,11 @@ class Option(object):
         return values
 
     def __repr__(self):
-        return '<%s.%s [%s]>' % (self.__class__.__module__,
+        return '<{}.{} [{}]>'.format(self.__class__.__module__,
                                  self.__class__.__name__, self.option)
 
 
-class CommandLineHelper(object):
+class CommandLineHelper:
     '''Helper class to handle the various ways options can be given either
     on the command line of through the environment.
 
@@ -441,7 +445,7 @@ class CommandLineHelper(object):
         elif option.env and args is self._args:
             env = self._environ.get(option.env)
             if env is not None:
-                arg = '%s=%s' % (option.env, env)
+                arg = '{}={}'.format(option.env, env)
                 origin = 'environment'
 
         origin = self._origins.get(arg, origin)
@@ -481,5 +485,5 @@ class CommandLineHelper(object):
 
     def __iter__(self):
         for d in (self._args, self._extra_args):
-            for arg, pos in d.itervalues():
+            for arg, pos in list(d.values()):
                 yield arg
